_G.NumHPAPS = _G.NumHPAPS or {}

NumHPAPS.ModPath = ModPath
NumHPAPS.SavePath = SavePath .. "NumHPAPSOptions.json"
NumHPAPS.Options = NumHPAPS.Options or {}
NumHPAPS.Menu = "NumHPAPSMainMenu"

dofile( NumHPAPS.ModPath .. "lua/options.lua" )

local HookFiles = {

	[ "lib/managers/hud/hudteammate" ] 	= "lua/hudteammate.lua"
	
}

function NumHPAPS:Save()

	local data = io.open( self.SavePath , "w+" )
	
	if data then
		data:write( json.encode( self.Options ) )
		data:close()
	end
	
end

function NumHPAPS:Load()

	local data = io.open( self.SavePath , "r" )
	
	if data then
		self.Options = json.decode( data:read( "*all" ) )
		data:close()
	end
	
end

function NumHPAPS:DefaultSettings()

	for k , v in pairs( NumHPAPS.MenuOptions.Slider ) do
		if self:HasSetting( k ) == nil then NumHPAPS.Options[ k ] = v[ 7 ] end
	end
	
	self:Save()

end

function NumHPAPS:HasSetting( s )

	return NumHPAPS.Options[ s ]
	
end

NumHPAPS:Load()
NumHPAPS:DefaultSettings()

Hooks:Add( "MenuManagerSetupCustomMenus" , "NumHPAPSMenuManagerPostSetupCustomMenus" , function( self , nodes )
    
	MenuHelper:NewMenu( NumHPAPS.Menu )
	
	for k , v in pairs( NumHPAPS.MenuOptions.Menu ) do
		MenuHelper:NewMenu( k )
	end
	
end )

Hooks:Add( "LocalizationManagerPostInit" , "NumHPAPSLocalizationManagerPostInit" , function( self )

	self:load_localization_file( NumHPAPS.ModPath .. "loc/english.json" )
	
	for _ , file in pairs( file.GetFiles( NumHPAPS.ModPath .. "loc/" ) ) do
		local loc = file:match( '^(.*).json$' )
		
		if loc and Idstring( loc ) and Idstring( loc ):key() == SystemInfo:language():key() then
			self:load_localization_file( NumHPAPS.ModPath .. "loc/" .. file )
		end
	end

end )

Hooks:Add( "MenuManagerBuildCustomMenus" , "NumHPAPSMenuManagerPostBuildCustomMenus" , function( self , nodes )
	
	nodes[ NumHPAPS.Menu ] = MenuHelper:BuildMenu( NumHPAPS.Menu , { focus_changed_callback = "NumHPAPSMenuMOTDFocus" } )
    MenuHelper:AddMenuItem( nodes["blt_options"] , NumHPAPS.Menu , "NumHPAPS_menu_title" , "NumHPAPS_menu_desc" )
	
	for k , v in pairs( NumHPAPS.MenuOptions.Menu ) do	
		nodes[ k ] = MenuHelper:BuildMenu( k , v[ 4 ] )
		MenuHelper:AddMenuItem( nodes[ NumHPAPS.Menu ] , k , v[ 1 ] , v[ 2 ] , v[ 3 ] )
	end
	
end )

Hooks:Add( "MenuManagerPopulateCustomMenus" , "NumHPAPSMenuManagerPostPopulateCustomMenus" , function( self , nodes )

	MenuCallbackHandler.NumHPAPSMainMenuButtonCallback = function( self ) end
	
	MenuHelper:AddButton({
		id 			= "NumHPAPSMainMenuButton",
		title 		= "",
		desc 		= "",
		callback 	= "NumHPAPSMainMenuButtonCallback",
		menu_id 	= "NumHPAPSMainMenu",
		localized 	= false
	})
	
	for k , v in pairs( NumHPAPS.MenuOptions.Slider ) do
	
		MenuCallbackHandler[ k .. "Slider" ] = function( self , item )
			NumHPAPS.Options[ k ] = item:value()
			NumHPAPS:Save()
		end
		
		MenuHelper:AddSlider({
			id 			= "ID" .. k .. "Slider",
			title 		= v[ 2 ],
			desc 		= v[ 3 ],
			callback 	= k .. "Slider",
			value 		= NumHPAPS.Options[ k ],
			min 		= v[ 4 ],
			max 		= v[ 5 ],
			step 		= v[ 6 ],
			show_value 	= true,
			menu_id 	= v[ 1 ]
		})
		
	end

end )

if RequiredScript then

	local requiredScript = RequiredScript:lower()
	
	if HookFiles[ requiredScript ] then
		dofile( NumHPAPS.ModPath .. HookFiles[ requiredScript ] )
	end
	
end