Hooks:PostHook(HUDTeammate, "init", "init_health_as_number_standalone", function(self, ...)
    local teammate_panel = self._panel:child("player")
	local radial_health_panel = teammate_panel:child("radial_health_panel")
    local HealthNum = radial_health_panel:text({
		name = "HealthNum",
		visible = true,
		text = "",
		-- color = Color.black:with_alpha(1),
		blend_mode = "normal",
		layer = 3,
		w = radial_health_panel:w(),
		h = radial_health_panel:h(),
		vertical = "top",
		align = "center",
		font_size = main_player and 22 or 18,
		font = "fonts/font_large_mf"
    })
    local Armorsize = radial_health_panel:text({
		name = "ArmorNum",
		visible = true,
		text = "",
		-- color = Color.black:with_alpha(1),
		blend_mode = "normal",
		layer = 3,
		w = radial_health_panel:w(),
		h = radial_health_panel:h(),
		vertical = "bottom",
		align = "center",
		font_size = main_player and 22 or 18,
		font = "fonts/font_large_mf"
    })
end)

Hooks:PostHook(HUDTeammate, "set_health", "set_health_health_as_number_standalone", function(self, data, ...)
	local teammate_panel = self._panel:child("player")
	local radial_health_panel = teammate_panel:child("radial_health_panel")
	local HealthNum = radial_health_panel:child("HealthNum")
	local set_health_alpha = NumHPAPS:HasSetting( "HealthAlpha" )
	local radial_health = radial_health_panel:child("radial_health")
	local radial_bg = radial_health_panel:child("radial_bg")
	
	radial_health:set_alpha(set_health_alpha)
	radial_bg:set_alpha(set_health_alpha)

	HealthNum:animate(callback(self, self, "_animate_hp"))
	local Value = math.clamp(data.current / data.total, 0, 1)
	local real_value = math.round((data.total * 10) * Value)
	HealthNum:set_text(real_value)
	if real_value > 35 then
      HealthNum:set_color(Color.white, Color.black:with_alpha(0.5))
	elseif real_value < 35 then
	  HealthNum:set_color(Color.red:with_alpha(0.5))
	end
end)

Hooks:PostHook(HUDTeammate, "set_armor", "set_armor_health_as_number_standalone", function(self, data, ...)
	local teammate_panel = self._panel:child("player")
	local radial_health_panel = teammate_panel:child("radial_health_panel")
	local ArmorNum = radial_health_panel:child("ArmorNum")
	local set_armor_alpha = NumHPAPS:HasSetting( "ArmorAlpha" )
	local radial_shield = radial_health_panel:child("radial_shield")
	local radial_bg = radial_health_panel:child("radial_bg")

	radial_shield:set_alpha(set_armor_alpha)
	radial_bg:set_alpha(set_armor_alpha)

	ArmorNum:animate(callback(self, self, "_animate_ap"))
	local Value = math.clamp(data.current / data.total, 0, 1)
	local real_value = math.round((data.total * 10) * Value)
	ArmorNum:set_text(real_value)
	if real_value > 35 then
      ArmorNum:set_color(Color.white, Color.black:with_alpha(0.5))
	elseif real_value < 35 then
	  ArmorNum:set_color(Color.red:with_alpha(0.5))
	end
end)

function HUDTeammate:_animate_hp()
    local t = 0
    local Healthsize = 25
	local teammate_panel = self._panel:child("player")
	local radial_health_panel = teammate_panel:child("radial_health_panel")
	local HealthNum = radial_health_panel:child("HealthNum")
	while t < 0.5 do
		t = t + coroutine.yield()
		local n = 1 - math.sin(t * 180)
		HealthNum:set_font_size(math.lerp(Healthsize + 1, Healthsize + 1, n))
	end
	HealthNum:set_font_size(Healthsize)
end

function HUDTeammate:_animate_ap()
    local t = 0
    local Armorsize = 25
	local teammate_panel = self._panel:child("player")
	local radial_health_panel = teammate_panel:child("radial_health_panel")
	local ArmorNum = radial_health_panel:child("ArmorNum")
	while t < 0.5 do
		t = t + coroutine.yield()
		local n = 1 - math.sin(t * 180)
		ArmorNum:set_font_size(math.lerp(Armorsize + 1, Armorsize + 1, n))
	end
	ArmorNum:set_font_size(Armorsize)
end

if CustomEOStandalone and CustomEOStandalone:getSetting({"WolfHUDCustomHUD", "ENABLED"}, true) or WolfHUD and WolfHUD:getSetting({"CustomHUD", "ENABLED"}, true) or VHUDPlus and VHUDPlus:getSetting({"CustomHUD", "HUDTYPE"}, 2) == 3 then
	local customhud_init = PlayerInfoComponent.PlayerStatus.init
	function PlayerInfoComponent.PlayerStatus:init(panel, owner, width, height, settings)
		customhud_init(self, panel, owner, width, height, settings)
		local custom_armor = self._panel:child("health_bg")
		local custom_health = self._panel:child("health_radial")
		local set_armor_alpha = NumHPAPS:HasSetting( "ArmorAlpha" )
		local set_health_alpha = NumHPAPS:HasSetting( "HealthAlpha" )
		custom_armor:set_alpha(set_armor_alpha)
		custom_health:set_alpha(set_health_alpha)
		self.HealthNum = self._panel:text({
			name = "HealthNum",
			visible = true,
			text = "",
			-- color = Color.Black,
			blend_mode = "normal",
			layer = 3,
			h = self._size,
			w = self._size,
			vertical = "top",
			align = "center",
			font_size = main_player and 22 or 18,
			font = "fonts/font_large_mf"
		})
		self.Armorsize = self._panel:text({
			name = "ArmorNum",
			visible = true,
			text = "",
			-- color = Color.Black,
			blend_mode = "normal",
			layer = 3,
			h = self._size,
			w = self._size,
			vertical = "bottom",
			align = "center",
			font_size = main_player and 22 or 18,
			font = "fonts/font_large_mf"
		})
	end

	local customhud_set_health = PlayerInfoComponent.PlayerStatus.set_health
	function PlayerInfoComponent.PlayerStatus:set_health(current, total)
		customhud_set_health(self, current, total)
		local Value = math.clamp(current / total, 0, 1)
		local real_value = math.round((total * 10) * Value)
		self.HealthNum:set_text(real_value)
		if real_value > 35 then
			self.HealthNum:set_color(Color.white)
		elseif real_value < 35 then
			self.HealthNum:set_color(Color.red)
		end
		self.HealthNum:animate(callback(self, self, "_animate_set_health") )
	end

	local customhud_set_armor = PlayerInfoComponent.PlayerStatus.set_armor
	function PlayerInfoComponent.PlayerStatus:set_armor(current, total)
		customhud_set_armor(self, current, total)
		local AValue = math.clamp(current / total, 0, 1)
		local Areal_value = math.round((total * 10) * AValue)
		self.Armorsize:set_text(Areal_value)
		if Areal_value > 35 then
			self.Armorsize:set_color(Color.white)
		elseif Areal_value < 35 then
			self.Armorsize:set_color(Color.red)
		end
		-- self.Armorsize:animate(callback(self, self, "_animate_set_health") )
	end

end